//+------------------------------------------------------------------+
//|                                                     .mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double Lots=0.1;
extern double TakeProfit=50;
extern double TrailingStop=20;
extern double MaxLots=7;
extern double pips=7;
extern double per_K=15;
extern double per_D=3;
extern double slow=3;
extern double zoneBUY=50;
extern double zoneSELL=70;
extern double MACDOpenLevel=3;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  double total,Cena,cnt,lot;
  double cenaoppos,l,sl;
  double MacdCurrent, MacdPrevious, SignalCurrent;
   double SignalPrevious;
   MacdCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   SignalCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
  total=OrdersTotal();
    if(total<1)
    {  
    if(iCustom(NULL,0,"StochasticML",per_K,per_D,slow,MODE_LWMA,1,0,1)>iCustom(NULL,0,"StochasticML",per_K,per_D,slow,MODE_LWMA,1,1,1)
      && iCustom(NULL,0,"StochasticML",per_K,per_D,slow,MODE_LWMA,1,1,1)<zoneBUY)//  
      if (MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious &&// MACD   MACD  
         MathAbs(MacdCurrent)>(MACDOpenLevel*Point))
      {
        sl=MaxLots*TrailingStop*Point+20*Point;// 
         OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-sl,Ask+TakeProfit*Point,0,Green); //
         }
     if(iCustom(NULL,0,"StochasticML",per_K,per_D,slow,MODE_LWMA,1,0,1)<iCustom(NULL,0,"StochasticML",per_K,per_D,slow,MODE_LWMA,1,1,1)
      && iCustom(NULL,0,"StochasticML",per_K,per_D,slow,MODE_LWMA,1,1,1)>zoneSELL)//  
       if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious && // MACD   MACD  
         MacdCurrent>(MACDOpenLevel*Point))
      {
         sl=MaxLots*TrailingStop*Point+20*Point;// 
         OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+sl,Bid-TakeProfit*Point,0,Red);//
         }      
      }
    if(total>0 && total<MaxLots)      
      {
      for(cnt=0;cnt<total;cnt++)
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      cenaoppos=OrderOpenPrice();// 
      lot=OrderLots();//
      if(OrderType()<=OP_SELL &&   
         OrderSymbol()==Symbol())  
        {
         if(OrderType()==OP_BUY)   //  
           {
           Cena=Ask;// 
            if((cenaoppos+pips*Point)<Cena)//   +()*  ,  
                {
                OrderSend(Symbol(),OP_BUY,lot,Ask,3,Bid-sl,Ask+TakeProfit*Point,0,Green);//    
                 return(0); 
                }
           }
         else 
           {
           Cena=Bid;// 
            if((cenaoppos-pips*Point)>Cena)//  - *  , //----
                                                                                        
              {
              OrderSend(Symbol(),OP_SELL,lot,Bid,3,Ask+sl,Bid-TakeProfit*Point,"macd sample",16384,0,Red);    //            
               return(0); 
              }
           }
        }
      }
      for(cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()==OP_BUY)
        {  
         if(TrailingStop>0)  
           {                 
            if(Bid-OrderOpenPrice()>Point*TrailingStop)// -     
              {
               if(OrderStopLoss()<Bid-Point*TrailingStop)//   -  (  )
                 {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,Ask+TakeProfit*Point,0,Green);
                  return(0);// 
                 }
              }
           }
         }
         
       else
            {
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))//  -    
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))//    +  ( )
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,Bid-TakeProfit*Point,0,Red);//  
                     return(0);
                    }
                 }
              }
           }
           
//----------------------------------
}}